﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ConsoleProviderAndClient
{
    /// <summary>
    /// Клиент класса Provider
    /// </summary>
    class Client
    {
        //fields
        Provider provider;
        string fieldC1;
        int fieldC2;
        
        const string NEWLINE = "\n\r";
        //Конструкторы класса
        public Client(string p1, int p2, string c1, int c2)
        {
            fieldC1 = c1.ToLower(); fieldC2 = c2-2;
            provider = new Provider(p1,p2);
        }
        public Client()
        {
            fieldC1 = ""; fieldC2 = 0; 
            provider = new Provider();
        }
        /// <summary>
        /// Метод, использующий поле класса provider
        /// для работы с методами класса Provider
        /// </summary>
        /// <returns>композиция строк провайдера и клиента </returns>
        public string MethodClient1()
        {
            string res = provider.MethodPD() + NEWLINE;             
            res += "Объект класса Client" + NEWLINE;
            res += string.Format("Мои поля: поле1 = {0}, поле2 = {1}",
                fieldC1, fieldC2);
            return res;
        }
        /// <summary>
        /// Метод, использующий модуль Provider
        /// для работы со статическим методом класса Provider
        /// </summary>
        /// <returns>композиция строк провайдера и клиента </returns>
        public string MethodClient2()
        {
            string res = Provider.MethodPS() + NEWLINE;
            res += "Объект класса Client" + NEWLINE;
            res += string.Format("Мои поля: поле1 = {0}, поле2 = {1}",
                fieldC1, fieldC2);
            return res;
        }
        /// <summary>
        /// Метод, использующий локальный объект класса provider
        /// для работы с методами класса Provider
        /// </summary>
        /// <returns>композиция строк провайдера и клиента </returns>
        public string MethodClient3()
        {
            Provider local_provider =
                new Provider("Локальный объект Provider", 77);
            string res = local_provider.MethodPD() + NEWLINE;
            res += "Объект класса Client" + NEWLINE;
            res += string.Format("Мои поля: поле1 = {0}, поле2 = {1}",
                fieldC1, fieldC2);
            return res;
        }

    }
}
