﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Collections;

namespace WindowsParentsAndChildrenClasses
{
    public partial class FormStack : Form
    {
        ListStack stack;
        ArrayList list;
        const string NL = "\r\n";
        public FormStack()
        {
            InitializeComponent();
        }

        private void buttonCreate_Click(object sender, EventArgs e)
        {
            stack = new ListStack();
            list = new ArrayList();
            textBoxResult.Text = "Стек создан!";
            ShowStack();
        }
        void ShowStack()
        {
            list = stack.StackToList();
            listBoxStack.Items.Clear();
            foreach (int item in list)
                listBoxStack.Items.Add(item);
        }

        private void buttonPut_Click(object sender, EventArgs e)
        {
            if (stack == null)
            {
                textBoxResult.Text = "Создайте стек!";
                return;
            }
            int item = 0;
            try
            {
                item = int.Parse(textBoxItem.Text);
            }
            catch (Exception)
            {
                textBoxResult.Text =
                    "Некорректно задан элемент item!" +
                    NL + "Необходимо целое число!";
                return;
            }
            stack.Put(item);
            textBoxResult.Text =
                " Операция Put выполнена успешно!";
            ShowStack();
        }

        private void buttonRemove_Click(object sender, EventArgs e)
        {
            if (stack == null)
            {
                textBoxResult.Text = "Создайте стек!";
                return;
            }
            if (!stack.IsEmpty())
            {
                textBoxItem.Text = stack.Item().ToString();
                stack.Remove();
                textBoxResult.Text =
                    " Операция Remove выполнена успешно!";
                ShowStack();
            }
            else
                textBoxResult.Text =
                    "Стек пуст. Удаление невозможно!" +
                NL + " Операция Remove не выполнена!";
            
        }

        private void buttonItem_Click(object sender, EventArgs e)
        {
            if (stack == null)
            {
                textBoxResult.Text = "Создайте стек!";
                return;
            }
            if (!stack.IsEmpty())
            {
                int item = stack.Item();
                textBoxItem.Text = item.ToString();
                textBoxResult.Text =
                    " Операция Item выполнена успешно!";                
            }
            else
                textBoxResult.Text =
                    "Стек пуст. Чтение невозможно!" +
                NL + " Операция Item не выполнена!";
        }

        private void buttonIsEmpty_Click(object sender, EventArgs e)
        {
            if (stack == null)
            {
                textBoxResult.Text = "Создайте стек!";
                return;
            }
            if (stack.IsEmpty())
                textBoxResult.Text = "Стек пуст!";
            else
                textBoxResult.Text = "Стек не пуст!";
        }        
    }
}
